// Échange d'objets de base

#include <mmaple/mmaple.hpp>
#include <mmaple/maple_ops.hpp>

using namespace mmx;
int main (int argc, char** argv) {
  maple_session mpl;
  
  maple_object x = maple_fresh_local_name (mpl, "x");
  maple_object expr = derive (pow (sin (x), 3), x);
  mmout << expr << "\n";
  assign (x, 42);
  mmout << expr << " ≈ " << evalf (expr) << "\n";
  
  maple_object mpl_env = maple_eval_statement (mpl, "[anames ('environment')]:");
  vector<maple_object> env = as<vector<maple_object> > (mpl_env);
  for (nat i=0; i < N (env); i++) {
    string name = as<string> (env[i]);
    if ('A' <= name[0] && name[0] <= 'Z')
      mmout << name << " = " << env[i] << "\n";
  }
}